Version 1.00
BEGIN Form MainForm
	AutoRedraw   = 0
	BackColor    = QBColor(7)
	BorderStyle  = 2
	Caption      = "Hilfesystem"
	ControlBox   = 0
	Enabled      = -1
	ForeColor    = QBColor(0)
	Height       = Char(15)
	Left         = Char(16)
	MaxButton    = 0
	MinButton    = 0
	MousePointer = 0
	Tag          = ""
	Top          = Char(3)
	Visible      = -1
	Width        = Char(63)
	WindowState  = 0
	BEGIN CommandButton Themen
		BackColor    = QBColor(7)
		Cancel       = 0
		Caption      = "&Themen"
		Default      = 0
		DragMode     = 0
		Enabled      = -1
		Height       = Char(1)
		Left         = Char(1)
		MousePointer = 0
		TabIndex     = 0
		TabStop      = -1
		Tag          = ""
		Top          = Char(1)
		Visible      = -1
		Width        = Char(10)
	END
	BEGIN CommandButton Stichworte
		BackColor    = QBColor(7)
		Cancel       = 0
		Caption      = "&Stichworte"
		Default      = 0
		DragMode     = 0
		Enabled      = -1
		Height       = Char(1)
		Left         = Char(13)
		MousePointer = 0
		TabIndex     = 1
		TabStop      = -1
		Tag          = ""
		Top          = Char(1)
		Visible      = -1
		Width        = Char(14)
	END
	BEGIN CommandButton Ende
		BackColor    = QBColor(7)
		Cancel       = -1
		Caption      = "&Ende"
		Default      = 0
		DragMode     = 0
		Enabled      = -1
		Height       = Char(1)
		Left         = Char(51)
		MousePointer = 0
		TabIndex     = 2
		TabStop      = -1
		Tag          = ""
		Top          = Char(1)
		Visible      = -1
		Width        = Char(8)
	END
	BEGIN TextBox TextFeld
		BackColor    = QBColor(7)
		BorderStyle  = 1
		DragMode     = 0
		Enabled      = -1
		ForeColor    = QBColor(0)
		Height       = Char(12)
		Left         = Char(1)
		MousePointer = 0
		MultiLine    = -1
		ScrollBars   = 2
		TabIndex     = 3
		TabStop      = -1
		Tag          = ""
		Text         = ""
		Top          = Char(3)
		Visible      = -1
		Width        = Char(59)
	END
	BEGIN CommandButton Drucken
		BackColor    = QBColor(7)
		Cancel       = 0
		Caption      = "&Drucken"
		Default      = 0
		DragMode     = 0
		Enabled      = -1
		Height       = Char(1)
		Left         = Char(38)
		MousePointer = 0
		TabIndex     = 4
		TabStop      = -1
		Tag          = ""
		Top          = Char(1)
		Visible      = -1
		Width        = Char(11)
	END
END
DECLARE SUB KeineStichworte (Text AS STRING)
DECLARE SUB LoadTopic (Nummer AS INTEGER, Text AS STRING)
DECLARE SUB LoadStichwort (Nummer AS INTEGER, Text AS STRING)

   COMMON SHARED HelpWidth AS INTEGER
   COMMON SHARED IndexFile AS STRING, HelpFile AS STRING

   TYPE TopType
      Text AS STRING * 56
      OrgNr AS INTEGER
      Laenge AS INTEGER
      Pos AS LONG
   END TYPE

   TYPE IndType
      Text AS STRING * 56
      Topic AS INTEGER
      ByteOffset AS INTEGER
   END TYPE


SUB Ende_Click ()

   UNLOAD MainForm

END SUB

SUB Form_Load ()

   MainForm.Width = HelpWidth + 4
   MainForm.Left = (Screen.Width - MainForm.Width) \ 2
   IF Screen.Height = 25 THEN
      MainForm.Height = 21
      MainForm.Top = 2
   ELSE
      MainForm.Height = Screen.Height - 12
      MainForm.Top = (Screen.Height - MainForm.Height) \ 2
   END IF

   IF LEN(COMMAND$) THEN
      IF LEFT$(COMMAND$, 1) = "*" THEN
         LoadStichwort 0, MID$(COMMAND$, 2)
      ELSE
         LoadTopic 0, COMMAND$
      END IF
   ELSE
      LoadTopic 0, "HILFE"
   END IF

END SUB

SUB Form_Resize ()

   IF MainForm.Width < 6 + Stichworte.Width + Themen.Width THEN
      MainForm.Width = 6 + Stichworte.Width + Themen.Width
   END IF

   TextFeld.Width = MainForm.Width - 4
   TextFeld.Height = MainForm.Height - 5
   Drucken.Left = TextFeld.Left + TextFeld.Width - Ende.Width - Drucken.Width - 2
   IF Drucken.Left < 2 + Stichworte.Left + Stichworte.Width THEN
      Drucken.Left = 1: Drucken.Top = 2
   ELSE
      Drucken.Top = 1
   END IF

   Ende.Left = TextFeld.Left + TextFeld.Width - Ende.Width
   IF Ende.Left < 2 + Stichworte.Left + Stichworte.Width THEN
      Ende.Top = 2
   ELSE
      Ende.Top = 1
   END IF

END SUB

SUB KeineStichworte (Text AS STRING)

   DIM SuchText AS STRING * 5, CRLF AS STRING * 2
   CRLF = CHR$(13) + CHR$(10)
   SuchText = CRLF + ".S "

   Position = INSTR(Text, SuchText)
   DO WHILE Position
      Pos2 = INSTR(Position + 2, Text, CRLF)
      IF Pos2 = 0 THEN
         Text = LEFT$(Text, Position - 1)
         Position = 0
      ELSE
         Text = LEFT$(Text, Position - 1) + MID$(Text, Pos2)
         Position = INSTR(Position - 1, Text, SuchText)
      END IF
   LOOP
   IF LEFT$(Text, 3) = ".S " THEN
      Pos2 = INSTR(Text, CRLF)
      IF Pos2 = 0 THEN Text = "" ELSE Text = MID$(Text, Pos2 + 2)
   END IF

END SUB

SUB LoadStichwort (Nummer AS INTEGER, Text AS STRING)

   DIM LongOffset AS LONG, Buffer AS STRING
   DIM Index AS IndType, Topic AS TopType, Compare AS STRING * 56

   IF Nummer = 0 THEN
      OPEN IndexFile FOR BINARY AS #1
      GET #1, , LongOffset
      Anfang = 1: Schluss = (LOF(1) - LongOffset + 1) \ 60: Compare = Text
      DO
         Mitte = (Anfang + Schluss) \ 2
         GET #1, LongOffset + (Mitte - 1) * 60, Index
         IF Index.Text < Compare THEN
            Anfang = Mitte + 1
         ELSE
            Schluss = Mitte
         END IF
      LOOP UNTIL Anfang = Schluss
      Nummer = Anfang
      GET #1, LongOffset + (Nummer - 1) * 60, Index
      IF Index.Text <> Compare THEN
         MSGBOX "Das Stichwort " + Text + "" + CHR$(13) + CHR$(10) + "kann nicht gefunden werden.", 0, "Fehler"
         CLOSE 1
         LoadTopic 0, "HILFE"
         EXIT SUB
      END IF
   ELSE
      OPEN IndexFile FOR BINARY AS #1
      GET #1, , LongOffset
      GET #1, LongOffset + (Nummer - 1) * 64, Index
   END IF

   GET #1, 9 + (Index.Topic - 1) * 64, Topic
   Buffer = SPACE$(Topic.Laenge)
   CLOSE #1
   OPEN HelpFile FOR BINARY AS #1
   GET #1, Topic.Pos, Buffer
   KeineStichworte Buffer
   MainForm.Caption = "HILFE - " + RTRIM$(Topic.Text)
   TextFeld.Text = Buffer
   TextFeld.SelStart = Index.ByteOffset
   ON LOCAL ERROR RESUME NEXT
   TextFeld.SETFOCUS
   CLOSE 1

END SUB

SUB LoadTopic (Nummer AS INTEGER, Text AS STRING)

   DIM Topic AS TopType, Buffer AS STRING, LongVar AS LONG
   DIM Anfang AS INTEGER, Schluss AS INTEGER, Compare AS STRING * 56
   DIM Mitte AS INTEGER

   IF Nummer = 0 THEN
      OPEN IndexFile FOR BINARY AS #1
      GET #1, , LongVar
      Schluss = (LongVar - 9) \ 64: Anfang = 1: Compare = Text
      DO
         Mitte = (Anfang + Schluss) \ 2
         GET #1, (Mitte - 1) * 64 + 9, Topic
         IF Topic.Text < Compare THEN
            Anfang = Mitte + 1
         ELSE
            Schluss = Mitte
         END IF
      LOOP UNTIL Anfang = Schluss
      Nummer = Anfang
      GET #1, (Nummer - 1) * 64 + 9, Topic
      IF Topic.Text <> Compare THEN
         MSGBOX "Das Thema " + Text + "" + CHR$(13) + CHR$(10) + "kann nicht gefunden werden.", 0, "Fehler"
         CLOSE 1
         IF Text <> "HILFE" THEN LoadTopic 0, "HILFE"
         EXIT SUB
      END IF
   ELSE
      OPEN IndexFile FOR BINARY AS #1
      GET #1, 9 + (Nummer - 1) * 64, Topic
   END IF

   Buffer = SPACE$(Topic.Laenge)
   CLOSE 1
   OPEN HelpFile FOR BINARY AS #1
   GET #1, Topic.Pos, Buffer
   KeineStichworte Buffer
   TextFeld.Text = Buffer
   TextFeld.SelStart = 0
   MainForm.Caption = "HILFE - " + RTRIM$(Topic.Text)
   ON LOCAL ERROR RESUME NEXT
   TextFeld.SETFOCUS
   CLOSE 1

END SUB

SUB Stichworte_CLick ()

BEEP

END SUB

SUB Themen_Click ()

BEEP

END SUB

