DECLARE FUNCTION FindePfad (DateiName AS STRING) AS STRING

FUNCTION FindePfad (DateiName AS STRING) AS STRING

   ' Diese Konstante kann gendert werden, wenn z.B. die mit SET LIB= oder
   ' SET HELPFILES= o.. gesetzten Verzeichnisse durchsucht werden sollen
   CONST DurchsucheVariable = "PATH"

   DIM Pfad AS STRING, Path AS STRING, Semikolon AS INTEGER, Datei AS INTEGER
   Pfad = CURDIR$: IF RIGHT$(Pfad, 1) <> "\" THEN Pfad = Pfad + "\"
   Path = UCASE$(ENVIRON$(DurchsucheVariable)) + ";"

   ON LOCAL ERROR GOTO OpenFehler
   Datei = FREEFILE
   OPEN Pfad + DateiName FOR INPUT AS #Datei
   CLOSE Datei
   FindePfad = Pfad: EXIT FUNCTION

OpenFehler:
   Semikolon = INSTR(Path, ";")
   IF Semikolon = 0 THEN ' Alle durchsucht, nichts gefunden: leeren String zurckgeben
      FindePfad = "": EXIT FUNCTION
   ELSE
      Pfad = RTRIM$(LEFT$(Path, Semikolon - 1)) ' erste Angabe extrahieren
      Path = LTRIM$(MID$(Path, Semikolon + 1))  ' und aus Path lschen
      IF RIGHT$(Pfad, 1) <> "\" THEN Pfad = Pfad + "\"
   END IF
   RESUME

END FUNCTION

