REM $INCLUDE: 'MATH.BI'

DIM Variable AS INTEGER, Eingabe AS STRING
DIM Zahl AS SINGLE, XPos AS INTEGER, YPos AS INTEGER
DIM ReturnCode AS INTEGER

DO
   CLS
   INPUT "Wieviele Variable (2-7)? ", Variable
LOOP UNTIL Variable > 1 AND Variable < 8

DIM Matrix(1 TO Variable, 1 TO Variable) AS SINGLE
DIM Resultat(1 TO Variable) AS SINGLE

' Ausgabe der Variablenbezeichnungen
FOR i% = 1 TO Variable
   FOR j% = 1 TO Variable
      LOCATE i% * 2 + 2, j% * 10 - 2
      PRINT CHR$(96 + j%);
      IF j% < Variable THEN PRINT " + " ELSE PRINT " = "
   NEXT
NEXT

PRINT
PRINT "Bitte geben Sie nacheinander die Koeffizienten ein."
PRINT "Geben Sie QUIT ein, um abzubrechen; drcken Sie F1, "
PRINT "um die letzte Eingabe zu wiederhole.n."

' Taste F1 umdefinieren, damit INPUT auf sie reagiert
' (CHR$(27) lscht bisherige Eingabe, CHR$(255) ist
' Erkennungsmerkmal, CHR$(13) simuliert Drcken der ENTER-Taste)
KEY 1, CHR$(27) + CHR$(255) + CHR$(13)

' Koeffizienten einlesen
' (Koeffizienten in Matrix(), rechte Seite der Gleichung in
' Resultat())
i% = 0: j% = 1
DO
   j% = 1: i% = i% + 1
   DO
      YPos = i% * 2 + 2: XPos = j% * 10 - 8
      LOCATE YPos, XPos: PRINT SPACE$(6)
      LOCATE YPos, XPos: LINE INPUT Eingabe
      IF UCASE$(Eingabe) = "QUIT" THEN
         CLS : END
      ELSEIF Eingabe = CHR$(255) THEN
         IF j% = 1 AND i% = 1 THEN
            CLS : RUN
         ELSE
            j% = j% - 1
            IF j% = 0 THEN i% = i% - 1: j% = Variable + 1
         END IF
      ELSE
         Wert = VAL(Eingabe)
         IF j% > Variable THEN
            Resultat(i%) = Wert
         ELSE
            Matrix(i%, j%) = Wert
         END IF
         Eingabe = LTRIM$(STR$(Wert))
         IF LEN(Eingabe) < 6 THEN
            LOCATE YPos, XPos
            PRINT SPACE$(6 - LEN(Eingabe)); Eingabe
         END IF
         j% = j% + 1
      END IF
   LOOP UNTIL j% > Variable + 1
LOOP UNTIL i% = Variable

PRINT
PRINT "Danke. Die Lsung wird berechnet..."; TAB(80); ""
PRINT TAB(80); ""
PRINT TAB(80); ""

ReturnCode = MatSEqnS(Matrix(), Resultat())

SELECT CASE ReturnCode
CASE -1  ' Null-Determinante
   PRINT "System hat keine Lsung!"
CASE 0   ' Alles o.k.
   PRINT "Die Lsungen sind: ";
   FOR i% = 1 TO Variable
      PRINT CHR$(i% + 96); " ="; STR$(Resultat(i%)); "    ";
   NEXT
CASE ELSE 'irgendein BASIC-Fehler
   PRINT "Fehler"; ReturnCode
   PRINT "Lsung nicht mglich"
END SELECT

END

