DECLARE SUB PrintBufferAnzeige (Ctrl AS CONTROL, CID AS INTEGER, Aktiv AS INTEGER)
DECLARE FUNCTION PrintBuffer_CPaint (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER) AS INTEGER
DECLARE FUNCTION PrintBuffer_CTimer (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER) AS INTEGER
DECLARE FUNCTION PrintBuffer_CIntegerGet (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER, BYVAL PropertyID AS INTEGER, Value AS INTEGER) AS INTEGER
DECLARE FUNCTION PrintBuffer_CIntegerSet (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER, BYVAL PropertyID AS INTEGER, BYVAL Value AS INTEGER) AS INTEGER
DECLARE FUNCTION PrintBuffer_CLongGet (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER, BYVAL PropertyID AS INTEGER, Value AS LONG) AS INTEGER
DECLARE FUNCTION PrintBuffer_CLongSet (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER, BYVAL PropertyID AS INTEGER, BYVAL Value AS LONG) AS INTEGER
DECLARE FUNCTION PrintBuffer_CStringGet (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER, BYVAL PropertyID AS INTEGER, Value AS STRING, BYVAL Index AS INTEGER) AS INTEGER
DECLARE FUNCTION PrintBuffer_CStringSet (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER, BYVAL PropertyID AS INTEGER, Value AS STRING, BYVAL Index AS INTEGER) AS INTEGER
' ----------------------------------------------------------------------------
' PRBUF.BAS: Ereignisprozeduren fr benutzerdefinierte Steuerelemente
'
' Diese Ereignisprozedurschablonen fr benutzerdefinierte
' Steuerelemente wurden von CUSTGEN.EXE (Schablonengenerator
' fr benutzerdefinierte Steuerelemente) erzeugt.
' Das Dienstprogramm CUSTGEN.EXE erleichtert Ihnen das Entwickeln
' benutzerdefinierter Steuerelemente. Es ermglicht Ihnen, die
' Ereignisse, auf die Ihr benutzerdefiniertes Steuerelement reagieren
' soll, auszuwhlen,  und es erzeugt dann Codeschablonen
' fr das benutzerdefinierte Steuerelement und eine
' Registrierungsroutine fr diese Ereignisse.
'
' ndern Sie die Code-Schablonendatei wie erforderlich,
' dann erstellen Sie Ihr benutzerdefiniertes Steuerelement wie folgt:
'    ML -c <RegisterFile>           Geht von einem Masm 6.0-bersetzer aus.
'    BC /o <TemplateFile>;
'    DEL <TemplateFile.LIB>         Lscht evtl. vorhandene Bibliothek
'    LIB <TemplateFile.LIB>+<RegisterFile.OBJ>+<TemplateFile.OBJ>
'    LINK /Q <TemplateFile.LIB>,<TemplateFile.QLB>,,VBDOSQLB.LIB;
' Sie knnen mehrere benutzerdefinierte Steuerelemente zu einer einzelnen
' Quick-Bibliothek fr den Einsatz in der Programmierumgebung
' kombinieren. Verfahren Sie hierzu wie folgt:
'    DEL <CombinedLib.LIB>          Lscht die bestehende Bibliothek, falls
'                                   vorhanden.
'    LIB <CombinedLib.LIB>+<Cust1.LIB>+<Cust2.LIB>+<CustN.LIB>
'    LINK /Q <CombinedLib.LIB>,<CombinedLib.QLB>,,VBDOSQLB.LIB;
' Um eine Alternate Math-Bibliothek fr benutzerdefinierte Steuerelemente
' (statt der oben angegebenen Emulator Math-Bibliothek fr
' benutzerdefinierte Steuerelemente) zu erstellen, bersetzen Sie die
' TemplateFile-Prozedur mit der /FPa-Option. Anmerkung: eine Altmath-
' Bibliothek kann nicht zur Erstellung einer Quick-Bibliothek verwendet
'  werden.
'
' Copyright (C) 1982-1992 Microsoft Corporation
'
' Sie haben das lizenzgebhrfreie Recht, die mit Visual Basic
' fr MS-DOS gelieferten Beispielanwendungsdateien und
' Werkzeugsammlungen (und/oder jede modifizierte Version) auf jede Art
' und Weise, die Ihnen sinnvoll erscheint, zu benutzen, zu ndern,
' zu vervielfltigen und zu verteilen unter der Bedingung, da
' Sie zustimmen, da Microsoft keine Garantie, Verpflichtung oder Haftung
' fr irgendeine der Beispielanwendungsdateien oder Werkzeugsammlungen
' bernimmt.
' ----------------------------------------------------------------------------


' Include-Datei mit Konstantendefinitionen fr Property-, Event-,
' Method- und ControlType-Bezeichner.
'$INCLUDE: 'CUSTINCL.BI'

' Schaltet die Explicit-Option ein, um die Deklaration aller Variablen
' vor dem Einsatz zu erzwingen. Anmerkung: Dies ist eine wahlfreie
' Fehlerbeseitigungstechnik.
OPTION EXPLICIT


' Deklarationen der Callback-Routinen fr benutzerdefinierte Steuerelemente.
' Diese Callback-Routinen werden zum Festlegen und zur Ermittlung der
' Eigenschaften und zum Aufrufen von Methoden und Elementen fr
' benutzerdefinierte Steuerelemente verwendet.
'
' WICHTIG: Entfernen Sie alle unbenutzten Callback-Routinendeklarationen,
'    um den DGROUP-Verbrauch zu reduzieren.
'
'    AID = Attributbezeichner - Liste ist in Include-Datei CUSTINCL enthalten.
'    CID = Steuerelementbezeichner - Wird von Visual Basic intern erzeugt.
'    EID = Ereignisbezeichner - Liste ist in Include-Datei CUSTINCL enthalten.
'    MthID = Methodenbezeichner - Liste ist in Include-Datei CUSTINCL enthalten.
'    PID = Eigenschaftsbezeichner - Liste ist in Include-Datei CUSTINCL enthalten.

' Deklariert Callback-Routinen zum Aufrufen von Methoden und Ereignissen
' und zum Festlegen und Holen von Eigenschaften. Die von diesen
' Callback-Routinen bernommenen Variablennummern und Argumenttypen
' hngen von der aufgerufenen Methode bzw. dem aufgerufenen Ereignis ab.
DECLARE SUB InvokeEvent
DECLARE SUB InvokeMethod
DECLARE SUB GetProperty
DECLARE SUB SetProperty

' Deklariert Callback-Routinen zur Ermittlung des umgebenden Objekts
' eines Steuerelements. Diese Callback-Routine liefert einen
' Steuerelementbezeichner fr das umgebende Objekt.
DECLARE FUNCTION GetContainer (BYVAL CID AS INTEGER) AS INTEGER
 
' Deklariert Callback-Routine zum Festlegen der Steuerelementattribute
' (Zugriffstaste, Verfgbarkeit fr Fokus, Fhigkeit zum Auffangen von
' Richtungstasten und Textcursorposition.) Vollstndige Informationen
' zur Verwendung dieser Callback-Routine finden Sie im Abschnitt ber
' benutzerdefinierte Steuerelemente in der LIESMICH.TXT-Datei.
DECLARE SUB SetAttribute (BYVAL CID AS INTEGER, BYVAL AID AS INTEGER, BYVAL Value AS INTEGER)

' Deklariert eindeutige Callback-Routinen fr jeden Eigenschaftsdatentyp zum
' Festlegen und zur Ermittlung von Eigenschaftswerten, indem die die Callback-
' Routinen GetProperty und SetProperty, die jeden Datentyp bernehmen
' knnen, als Parallelbezeichnungen verwendet werden. Dies sorgt fr die
' Typprfung whrend der Prozeduraufrufe.
DECLARE SUB GetIntProperty ALIAS "GETPROPERTY" (Value AS INTEGER, BYVAL CID AS INTEGER, BYVAL PID AS INTEGER)
DECLARE SUB GetStringProperty ALIAS "GETPROPERTY" (Value AS STRING, BYVAL CID AS INTEGER, BYVAL PID AS INTEGER)
DECLARE SUB GetLongProperty ALIAS "GETPROPERTY" (Value AS LONG, BYVAL CID AS INTEGER, BYVAL PID AS INTEGER)
DECLARE SUB SetIntProperty ALIAS "SETPROPERTY" (BYVAL Value AS INTEGER, BYVAL CID AS INTEGER, BYVAL PID AS INTEGER)
DECLARE SUB SetStringProperty ALIAS "SETPROPERTY" (Value AS STRING, BYVAL CID AS INTEGER, BYVAL PID AS INTEGER)
DECLARE SUB SetLongProperty ALIAS "SETPROPERTY" (BYVAL Value AS LONG, BYVAL CID AS INTEGER, BYVAL PID AS INTEGER)

' Deklariert eindeutige Callback-Routinen zum Aufrufen jedes
' Benutzerereignisses, indem die Callback-Routine InvokeEvent, deren
' Variablenargumentanzahl und Datentyp vom aufgerufenen Ereignis abhngt,
' als Parallelbezeichnung verwendet wird. Dies sorgt fr Typprfung
' whrend der Prozeduraufrufe.
DECLARE SUB InvokeChangeEvent ALIAS "INVOKEEVENT" (BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeClickEvent ALIAS "INVOKEEVENT" (BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeCustomEvent ALIAS "INVOKEEVENT" (EventType AS INTEGER, BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeDblClickEvent ALIAS "INVOKEEVENT" (BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeDragDropEvent ALIAS "INVOKEEVENT" (BYVAL SourceCID AS INTEGER, X AS SINGLE, Y AS SINGLE, BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeDragOverEvent ALIAS "INVOKEEVENT" (BYVAL SourceCID AS INTEGER, X AS SINGLE, Y AS SINGLE, State AS INTEGER, BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeDropDownEvent ALIAS "INVOKEEVENT" (BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeGotFocusEvent ALIAS "INVOKEEVENT" (BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeKeyDownEvent ALIAS "INVOKEEVENT" (KeyCode AS INTEGER, Shift AS INTEGER, BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeKeyPressEvent ALIAS "INVOKEEVENT" (KeyAscii AS INTEGER, BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeKeyUpEvent ALIAS "INVOKEEVENT" (KeyCode AS INTEGER, Shift AS INTEGER, BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeLoadEvent ALIAS "INVOKEEVENT" (BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeLostFocusEvent ALIAS "INVOKEEVENT" (BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeMouseDownEvent ALIAS "INVOKEEVENT" (Button AS INTEGER, Shift AS INTEGER, X AS SINGLE, Y AS SINGLE, BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeMouseMoveEvent ALIAS "INVOKEEVENT" (Button AS INTEGER, Shift AS INTEGER, X AS SINGLE, Y AS SINGLE, BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeMouseUpEvent ALIAS "INVOKEEVENT" (Button AS INTEGER, Shift AS INTEGER, X AS SINGLE, Y AS SINGLE, BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokePaintEvent ALIAS "INVOKEEVENT" (BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokePathChangeEvent ALIAS "INVOKEEVENT" (BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokePatternChangeEvent ALIAS "INVOKEEVENT" (BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeResizeEvent ALIAS "INVOKEEVENT" (BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeTimerEvent ALIAS "INVOKEEVENT" (BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeUnloadEvent ALIAS "INVOKEEVENT" (Cancel AS INTEGER, BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)

' Deklariert eindeutige Callback-Routinen zum Aufrufen jeder Methode fr
' benutzerdefinierte Steuerelemente, indem die Callback-Routine
' InvokeMethod, deren Variablenargumentanzahl und Datentyp von der
' aufgerufenen Methode abhngen, als Parallelbezeichnung verwendet
' wird. Dies sorgt fr Typprfung whrend der Prozeduraufrufe.
DECLARE SUB InvokePrintMethod ALIAS "INVOKEMETHOD" (BYVAL CurrX AS INTEGER, BYVAL CurrY AS INTEGER, BYVAL FColor AS INTEGER, BYVAL BColor AS INTEGER, Text AS STRING, BYVAL NumArgs AS INTEGER, BYVAL CID AS INTEGER, BYVAL MthID AS INTEGER)
DECLARE SUB InvokePrintFormMethod ALIAS "INVOKEMETHOD" (BYVAL NumArgs AS INTEGER, BYVAL CID AS INTEGER, BYVAL MthID AS INTEGER)
DECLARE SUB InvokeCLSMethod ALIAS "INVOKEMETHOD" (BYVAL NumArgs AS INTEGER, BYVAL CID AS INTEGER, BYVAL MthID AS INTEGER)
DECLARE SUB InvokeHideMethod ALIAS "INVOKEMETHOD" (BYVAL NumArgs AS INTEGER, BYVAL CID AS INTEGER, BYVAL MthID AS INTEGER)
DECLARE SUB InvokeShowMethod ALIAS "INVOKEMETHOD" (BYVAL Modal AS INTEGER, BYVAL NumArgs AS INTEGER, BYVAL CID AS INTEGER, BYVAL MthID AS INTEGER)
DECLARE SUB InvokeRefreshMethod ALIAS "INVOKEMETHOD" (BYVAL NumArgs AS INTEGER, BYVAL CID AS INTEGER, BYVAL MthID AS INTEGER)
DECLARE SUB InvokeMoveMethod ALIAS "INVOKEMETHOD" (BYVAL mLeft AS INTEGER, BYVAL mTop AS INTEGER, BYVAL mWidth AS INTEGER, BYVAL mHeight AS INTEGER, BYVAL NumArgs AS INTEGER, BYVAL CID AS INTEGER, BYVAL MthID AS INTEGER)
DECLARE SUB InvokeSetFocusMethod ALIAS "INVOKEMETHOD" (BYVAL NumArgs AS INTEGER, BYVAL CID AS INTEGER, BYVAL MthID AS INTEGER)
DECLARE SUB InvokeDragMethod ALIAS "INVOKEMETHOD" (BYVAL Action AS INTEGER, BYVAL NumArgs AS INTEGER, BYVAL CID AS INTEGER, BYVAL MthID AS INTEGER)

SUB PrintBufferAnzeige (Ctrl AS CONTROL, CID AS INTEGER, Aktiv AS INTEGER)

   DIM Wert AS INTEGER, Zeichen AS STRING * 1

   GetIntProperty Wert, CID, Prop_Visible
   IF Wert THEN
      IF Aktiv THEN
         GetIntProperty Wert, CID, PROP_Style
         Wert = (Wert + 1) MOD 4
         SetIntProperty Wert, CID, PROP_Style
         SELECT CASE Wert
         CASE 0: Zeichen = ""
         CASE 1: Zeichen = "/"
         CASE 2: Zeichen = "-"
         CASE 3: Zeichen = "\"
         END SELECT
      ELSE
         Zeichen = " "
      END IF
      InvokePrintMethod 0, 0, Ctrl.ForeColor, Ctrl.BackColor, Zeichen, 5, CID, METHOD_PRINT
   END IF

END SUB

FUNCTION PrintBuffer_CIntegerGet (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER, BYVAL PropertyID AS INTEGER, Value AS INTEGER) AS INTEGER

   SELECT CASE PropertyID
   CASE PROP_Value, Prop_Visible, Prop_ForeColor, Prop_BackColor
      GetIntProperty Value, ControlID, PropertyID
   CASE ELSE
      PrintBuffer_CIntegerGet = 422
   END SELECT

END FUNCTION

FUNCTION PrintBuffer_CIntegerSet (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER, BYVAL PropertyID AS INTEGER, BYVAL Value AS INTEGER) AS INTEGER

   SELECT CASE PropertyID
   CASE PROP_Value
      IF Value < 1 OR Value > 260 THEN
         PrintBuffer_CIntegerSet = 380
      ELSE
         SetIntProperty Value, ControlID, PropertyID
      END IF
   CASE Prop_Visible, Prop_ForeColor, Prop_BackColor
      SetIntProperty Value, ControlID, PropertyID
   CASE ELSE
      PrintBuffer_CIntegerSet = 422
   END SELECT

END FUNCTION

FUNCTION PrintBuffer_CLongGet (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER, BYVAL PropertyID AS INTEGER, Value AS LONG) AS INTEGER

   PrintBuffer_CLongGet = 422

END FUNCTION

FUNCTION PrintBuffer_CLongSet (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER, BYVAL PropertyID AS INTEGER, BYVAL Value AS LONG) AS INTEGER

   PrintBuffer_CLongSet = 422

END FUNCTION

FUNCTION PrintBuffer_CPaint (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER) AS INTEGER

   PrintBufferAnzeige Ctrl, ControlID, 0

END FUNCTION

FUNCTION PrintBuffer_CStringGet (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER, BYVAL PropertyID AS INTEGER, Value AS STRING, BYVAL Index AS INTEGER) AS INTEGER

   IF PropertyID = PROP_Text OR PropertyID = PROP_Tag THEN
      GetStringProperty Value, ControlID, PropertyID
   ELSE
      PrintBuffer_CStringGet = 422
   END IF

END FUNCTION

FUNCTION PrintBuffer_CStringSet (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER, BYVAL PropertyID AS INTEGER, Value AS STRING, BYVAL Index AS INTEGER) AS INTEGER

   DIM Dauer AS INTEGER
   IF PropertyID = PROP_Text THEN
      SetStringProperty Value, ControlID, PropertyID
      IF LEN(Value) THEN
         GetIntProperty Dauer, ControlID, PROP_Value
         SetLongProperty Dauer * 250, ControlID, PROP_Interval
'         SetIntProperty -1, ControlID, PROP_Enabled
      ELSE
         'SetIntProperty 0, ControlID, PROP_Enabled
      END IF
   ELSEIF PropertyID = PROP_Tag THEN
      SetStringProperty Value, ControlID, PropertyID
   ELSE
      PrintBuffer_CStringSet = 422
   END IF

END FUNCTION

FUNCTION PrintBuffer_CTimer (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER) AS INTEGER

    DIM Drucken AS STRING

    PrintBufferAnzeige Ctrl, ControlID, -1

    GetStringProperty Drucken, ControlID, PROP_Text
    IF LEN(Drucken) = 0 THEN
       SetIntProperty 0, ControlID, PROP_Interval
       ' Custom-Event 0 bedeutet: Alles klar, Text gedruckt
       PrintBufferAnzeige Ctrl, ControlID, 0
       InvokeCustomEvent 0, ControlID, EVENT_Custom
    ELSE
       ON LOCAL ERROR RESUME NEXT
       Printer.PRINT LEFT$(Drucken, 1000);
       IF ERR THEN
          ' Custom-Event 1 bedeutet: Fehler beim Drucken
          InvokeCustomEvent 1, ControlID, EVENT_Custom
       ELSE
          IF LEN(Drucken) > 1000 THEN
             SetStringProperty MID$(Drucken, 1001), ControlID, PROP_Text
          ELSE
             SetStringProperty "", ControlID, PROP_Text
          END IF
       END IF
    END IF
    PrintBuffer_CTimer = 0

END FUNCTION

