DECLARE SUB SchalterStatusAnzeigen (Ctrl AS CONTROL, CID AS INTEGER)
DECLARE FUNCTION Schalter_CClick (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER) AS INTEGER
DECLARE FUNCTION Schalter_CIntegerGet (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER, BYVAL PropertyID AS INTEGER, Value AS INTEGER) AS INTEGER
DECLARE FUNCTION Schalter_CIntegerSet (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER, BYVAL PropertyID AS INTEGER, BYVAL Value AS INTEGER) AS INTEGER
DECLARE FUNCTION Schalter_CKeyPress (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER, KeyAscii AS INTEGER) AS INTEGER
DECLARE FUNCTION Schalter_CLongGet (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER, BYVAL PropertyID AS INTEGER, Value AS LONG) AS INTEGER
DECLARE FUNCTION Schalter_CLongSet (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER, BYVAL PropertyID AS INTEGER, BYVAL Value AS LONG) AS INTEGER
DECLARE FUNCTION Schalter_CPaint (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER) AS INTEGER
DECLARE FUNCTION Schalter_CStringGet (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER, BYVAL PropertyID AS INTEGER, Value AS STRING, BYVAL Index AS INTEGER) AS INTEGER
DECLARE FUNCTION Schalter_CStringSet (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER, BYVAL PropertyID AS INTEGER, Value AS STRING, BYVAL Index AS INTEGER) AS INTEGER

'$INCLUDE: 'CUSTINCL.BI'
'$INCLUDE: 'CONSTANT.BI'
OPTION EXPLICIT


DECLARE SUB InvokeEvent
DECLARE SUB InvokeMethod
DECLARE SUB GetProperty
DECLARE SUB SetProperty

DECLARE FUNCTION GetContainer (BYVAL CID AS INTEGER) AS INTEGER
DECLARE SUB SetAttribute (BYVAL CID AS INTEGER, BYVAL AID AS INTEGER, BYVAL Value AS INTEGER)
DECLARE SUB GetIntProperty ALIAS "GETPROPERTY" (Value AS INTEGER, BYVAL CID AS INTEGER, BYVAL PID AS INTEGER)
DECLARE SUB GetStringProperty ALIAS "GETPROPERTY" (Value AS STRING, BYVAL CID AS INTEGER, BYVAL PID AS INTEGER)
DECLARE SUB GetLongProperty ALIAS "GETPROPERTY" (Value AS LONG, BYVAL CID AS INTEGER, BYVAL PID AS INTEGER)
DECLARE SUB SetIntProperty ALIAS "SETPROPERTY" (BYVAL Value AS INTEGER, BYVAL CID AS INTEGER, BYVAL PID AS INTEGER)
DECLARE SUB SetStringProperty ALIAS "SETPROPERTY" (Value AS STRING, BYVAL CID AS INTEGER, BYVAL PID AS INTEGER)
DECLARE SUB SetLongProperty ALIAS "SETPROPERTY" (BYVAL Value AS LONG, BYVAL CID AS INTEGER, BYVAL PID AS INTEGER)
DECLARE SUB InvokeChangeEvent ALIAS "INVOKEEVENT" (BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeClickEvent ALIAS "INVOKEEVENT" (BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeCustomEvent ALIAS "INVOKEEVENT" (EventType AS INTEGER, BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeDblClickEvent ALIAS "INVOKEEVENT" (BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeDragDropEvent ALIAS "INVOKEEVENT" (BYVAL SourceCID AS INTEGER, X AS SINGLE, Y AS SINGLE, BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeDragOverEvent ALIAS "INVOKEEVENT" (BYVAL SourceCID AS INTEGER, X AS SINGLE, Y AS SINGLE, State AS INTEGER, BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeDropDownEvent ALIAS "INVOKEEVENT" (BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeGotFocusEvent ALIAS "INVOKEEVENT" (BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeKeyDownEvent ALIAS "INVOKEEVENT" (KeyCode AS INTEGER, Shift AS INTEGER, BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeKeyPressEvent ALIAS "INVOKEEVENT" (KeyAscii AS INTEGER, BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeKeyUpEvent ALIAS "INVOKEEVENT" (KeyCode AS INTEGER, Shift AS INTEGER, BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeLoadEvent ALIAS "INVOKEEVENT" (BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeLostFocusEvent ALIAS "INVOKEEVENT" (BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeMouseDownEvent ALIAS "INVOKEEVENT" (Button AS INTEGER, Shift AS INTEGER, X AS SINGLE, Y AS SINGLE, BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeMouseMoveEvent ALIAS "INVOKEEVENT" (Button AS INTEGER, Shift AS INTEGER, X AS SINGLE, Y AS SINGLE, BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeMouseUpEvent ALIAS "INVOKEEVENT" (Button AS INTEGER, Shift AS INTEGER, X AS SINGLE, Y AS SINGLE, BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokePaintEvent ALIAS "INVOKEEVENT" (BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokePathChangeEvent ALIAS "INVOKEEVENT" (BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokePatternChangeEvent ALIAS "INVOKEEVENT" (BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeResizeEvent ALIAS "INVOKEEVENT" (BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeTimerEvent ALIAS "INVOKEEVENT" (BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokeUnloadEvent ALIAS "INVOKEEVENT" (Cancel AS INTEGER, BYVAL CID AS INTEGER, BYVAL EID AS INTEGER)
DECLARE SUB InvokePrintMethod ALIAS "INVOKEMETHOD" (BYVAL CurrX AS INTEGER, BYVAL CurrY AS INTEGER, BYVAL FColor AS INTEGER, BYVAL BColor AS INTEGER, Text AS STRING, BYVAL NumArgs AS INTEGER, BYVAL CID AS INTEGER, BYVAL MthID AS INTEGER)
DECLARE SUB InvokePrintFormMethod ALIAS "INVOKEMETHOD" (BYVAL NumArgs AS INTEGER, BYVAL CID AS INTEGER, BYVAL MthID AS INTEGER)
DECLARE SUB invokeclsmethod ALIAS "INVOKEMETHOD" (BYVAL NumArgs AS INTEGER, BYVAL CID AS INTEGER, BYVAL MthID AS INTEGER)
DECLARE SUB InvokeHideMethod ALIAS "INVOKEMETHOD" (BYVAL NumArgs AS INTEGER, BYVAL CID AS INTEGER, BYVAL MthID AS INTEGER)
DECLARE SUB InvokeShowMethod ALIAS "INVOKEMETHOD" (BYVAL MODAL AS INTEGER, BYVAL NumArgs AS INTEGER, BYVAL CID AS INTEGER, BYVAL MthID AS INTEGER)
DECLARE SUB InvokeRefreshMethod ALIAS "INVOKEMETHOD" (BYVAL NumArgs AS INTEGER, BYVAL CID AS INTEGER, BYVAL MthID AS INTEGER)
DECLARE SUB InvokeMoveMethod ALIAS "INVOKEMETHOD" (BYVAL mLeft AS INTEGER, BYVAL mTop AS INTEGER, BYVAL mWidth AS INTEGER, BYVAL mHeight AS INTEGER, BYVAL NumArgs AS INTEGER, BYVAL CID AS INTEGER, BYVAL MthID AS INTEGER)
DECLARE SUB InvokeSetFocusMethod ALIAS "INVOKEMETHOD" (BYVAL NumArgs AS INTEGER, BYVAL CID AS INTEGER, BYVAL MthID AS INTEGER)
DECLARE SUB InvokeDragMethod ALIAS "INVOKEMETHOD" (BYVAL Action AS INTEGER, BYVAL NumArgs AS INTEGER, BYVAL CID AS INTEGER, BYVAL MthID AS INTEGER)

' Diese Prozedur wird immer aufgerufen, wenn sich die Schaltereinstellung ndert.
' Sie zeichnet die Einstellung neu, ndert aber sonst nichts.
SUB SchalterStatusAnzeigen (Ctrl AS CONTROL, CID AS INTEGER)

	DIM LetzterStand AS INTEGER, Text AS STRING, TastenPos AS INTEGER
	DIM AlteFarbe AS INTEGER

	' ungenutzte Mode-Eigenschaft wird mibraucht, um letzten Schalterstand zu speichern:
	GetIntProperty LetzterStand, CID, PROP_Mode

	' ungenutzte SelText-Eigenschaft wird benutzt, um die "wahre" Beschriftung
	' (ohne eventuelles &-Zeichen, dafr mit Pfeil) zu speichern - vgl. CPaint-Prozedur
	GetStringProperty Text, CID, PROP_SelText

	' ungenutzte Style-Eigenschaft speichert, an welcher Stelle in Text ein Buchstabe
	' hervorgehoben werden soll - vgl. CPaint
	GetIntProperty TastenPos, CID, PROP_Style

	' Letzter Stand wird gelscht und neuer wird geschrieben
	InvokePrintMethod 0, LetzterStand, Ctrl.ForeColor, Ctrl.BackColor, SPACE$(LEN(Text)), 5, CID, METHOD_Print
	InvokePrintMethod 0, Ctrl.Value, Ctrl.ForeColor, Ctrl.BackColor, Text, 5, CID, METHOD_Print
	IF TastenPos THEN
		AlteFarbe = Ctrl.ForeColor ' Diese Mimik wird bentigt, weil der folgende Aufruf...
		InvokePrintMethod TastenPos - 1, Ctrl.Value, SCREEN.ControlPanel(ACCESSKEY_FORECOLOR), Ctrl.BackColor, MID$(Text, TastenPos, 1), 5, CID, METHOD_Print
		Ctrl.ForeColor = AlteFarbe ' ... fehlerhafterweise die ForeColor-Eigenschaft ndert!
	END IF

	' Neuer Stand wird in Mode gespeichert; Cursor wird gesetzt
	SetIntProperty Ctrl.Value, CID, PROP_Mode
	SetIntProperty Ctrl.Value, CID, PROP_CurrentY: SetIntProperty 0, CID, PROP_CurrentX

END SUB

FUNCTION Schalter_CClick (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER) AS INTEGER

	' Dadurch, da ich nicht SetIntProperty verwende, sondern direkt
	' (ber Ctrl) auf das Steuerelement zugreife, werden die IntegerSet-
	' und -Get-Ereignisse aufgerufen.
	Ctrl.Value = Ctrl.Value + 1

END FUNCTION

FUNCTION Schalter_CIntegerGet (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER, BYVAL PropertyID AS INTEGER, Value AS INTEGER) AS INTEGER

	SELECT CASE PropertyID
	CASE PROP_Value, PROP_ForeColor, PROP_Visible, PROP_Enabled, PROP_BackColor, PROP_Left, PROP_Height, PROP_Top, PROP_Width
		GetIntProperty Value, ControlID, PropertyID
	CASE ELSE
		 Schalter_CIntegerGet = 422
	END SELECT

END FUNCTION

FUNCTION Schalter_CIntegerSet (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER, BYVAL PropertyID AS INTEGER, BYVAL Value AS INTEGER) AS INTEGER

	SELECT CASE PropertyID
	CASE PROP_Value
		IF Ctrl.Value <> Value THEN
			SetIntProperty Value MOD Ctrl.Height, ControlID, PropertyID
			SchalterStatusAnzeigen Ctrl, ControlID
			InvokeChangeEvent ControlID, EVENT_Change
		END IF
	CASE PROP_ForeColor, PROP_Visible, PROP_Enabled, PROP_BackColor, PROP_Left, PROP_Height, PROP_Top, PROP_Width
		SetIntProperty Value, ControlID, PropertyID
	CASE ELSE
		 Schalter_CIntegerSet = 422
	END SELECT

END FUNCTION

FUNCTION Schalter_CKeyPress (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER, KeyAscii AS INTEGER) AS INTEGER

	' Siehe Bemerkung bei Schalter_CClick!
	Ctrl.Value = Ctrl.Value + 1

END FUNCTION

FUNCTION Schalter_CLongGet (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER, BYVAL PropertyID AS INTEGER, Value AS LONG) AS INTEGER

	Schalter_CLongGet = 422

END FUNCTION

FUNCTION Schalter_CLongSet (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER, BYVAL PropertyID AS INTEGER, BYVAL Value AS LONG) AS INTEGER

	Schalter_CLongSet = 422

END FUNCTION

FUNCTION Schalter_CPaint (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER) AS INTEGER

	DIM StartSpalte AS INTEGER, AktuellPos AS INTEGER
	DIM QuerStrich AS INTEGER, Text AS STRING, Zaehler AS INTEGER
	DIM i AS INTEGER, TastenPos AS INTEGER

	invokeclsmethod 0, ControlID, METHOD_Cls
	IF LEN(Ctrl.Text) = 0 THEN EXIT FUNCTION

	' SelText-Eigenschaft einstellen, die von SchalterStatusAnzeigen verwendet wird
	Text = Ctrl.Caption + " "
	FOR i = 1 TO LEN(Text) - 3
		IF MID$(Text, i, 1) = "&" THEN
			Text = LEFT$(Text, i - 1) + MID$(Text, i + 1)
			IF MID$(Text, i, 1) <> "&" THEN TastenPos = i: EXIT FOR
		END IF
	NEXT
	SetStringProperty Text, ControlID, PROP_SelText: SetIntProperty TastenPos, ControlID, PROP_Style
	' Mit SetAttribute festlegen, da die durch & markierte Taste die Zugriffstaste sein soll
	IF TastenPos THEN SetAttribute ControlID, ATTR_AccessKey, ASC(MID$(Text, TastenPos))

	StartSpalte = LEN(Text) + 1: AktuellPos = 0
	DO
		QuerStrich = INSTR(AktuellPos + 1, Ctrl.Text, "/")
		IF QuerStrich = 0 THEN QuerStrich = LEN(Ctrl.Text) + 1
		Text = MID$(Ctrl.Text, AktuellPos + 1, QuerStrich - 1 - AktuellPos)
		InvokePrintMethod StartSpalte, Zaehler, Ctrl.ForeColor, Ctrl.BackColor, Text, 5, ControlID, METHOD_Print
		Zaehler = Zaehler + 1: AktuellPos = QuerStrich
	LOOP UNTIL AktuellPos > LEN(Ctrl.Text)

	' Hhe des Steuerelements je nach Anzhl der in Text-Eigenschaft enthaltenen Elemente anpassen
	IF Ctrl.Height <> Zaehler THEN Ctrl.Height = Zaehler

	' Cursor einstellen
	SetAttribute ControlID, ATTR_TextCursor, TC_Underscore

	SchalterStatusAnzeigen Ctrl, ControlID

END FUNCTION

FUNCTION Schalter_CStringGet (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER, BYVAL PropertyID AS INTEGER, Value AS STRING, BYVAL Index AS INTEGER) AS INTEGER

	SELECT CASE PropertyID
	CASE PROP_Tag, PROP_Caption, PROP_Text
		GetStringProperty Value, ControlID, PropertyID
	CASE ELSE
		Schalter_CStringGet = 422
	END SELECT

END FUNCTION

FUNCTION Schalter_CStringSet (Ctrl AS CONTROL, BYVAL ControlID AS INTEGER, BYVAL PropertyID AS INTEGER, Value AS STRING, BYVAL Index AS INTEGER) AS INTEGER

	SELECT CASE PropertyID
	CASE PROP_Tag
		SetStringProperty Value, ControlID, PropertyID
	CASE PROP_Caption, PROP_Text
		SetStringProperty Value, ControlID, PropertyID
		' Diese Zuweisung hat nicht viel Sinn, das mache ich nur, weil Schalter_CPaint eine Funktion ist und ich
		' keine Dummy-Variable verwenden will!
		SetIntProperty 0, ControlID, PROP_Value
		Schalter_CStringSet = Schalter_CPaint(Ctrl, ControlID)
	CASE ELSE
		Schalter_CStringSet = 422
	END SELECT

END FUNCTION

