DECLARE SUB MaxAlloc (Zeichenfolge AS STRING, Bezeichnung AS STRING)
DECLARE SUB StringDemo ()
REM $DYNAMIC

' das erste Segment fr den COMMON-Block:
' (Wir brauchen zwei Strings, um es zu fllen, denn ein
' String darf nur 32.767 Zeichen haben, und ein Segment
' hat 65.536 Byte!)
COMMON SHARED ErstesSegment1 AS STRING
COMMON SHARED ErstesSegment2 AS STRING

' das zweite Segment fr's Hauptprogramm:
DIM SHARED ZweitesSegment1 AS STRING
DIM SHARED ZweitesSegment2 AS STRING

' nun das SUB aufrufen
StringDemo

' Programmende
END

' Setzt den bergebenen String auf die maximal mgliche Lnge#
' und gibt diese aus
SUB MaxAlloc (Zeichenfolge AS STRING, Bezeichnung AS STRING)

   ON LOCAL ERROR RESUME NEXT
   PRINT "Speicher fr "; Bezeichnung; ": ";
   FOR i% = 1000 TO 31000 STEP 1000
      Zeichenfolge = SPACE$(i%)
      IF ERR THEN PRINT FORMAT$(i% - 1000); : EXIT FOR
   NEXT
   IF ERR = 0 THEN PRINT "31000";
   PRINT " temporre Strings:"; FRE("")

END SUB

SUB StringDemo ()

   ' das dritte Segment fr alle Prozeduren und Funktionen
   DIM DrittesSegment1 AS STRING, DrittesSegment2 AS STRING
   ' ein weiteres Segment fr jede Prozedur, die String-Arrays hat
   DIM WeiteresSegment(1 TO 2) AS STRING

   ' nun alles vollschreiben
   MaxAlloc ErstesSegment1, "COMMON-Segment (1)"
   MaxAlloc ErstesSegment2, "COMMON-Segment (2)"
   MaxAlloc ZweitesSegment1, "Modul-Segment (1)"
   MaxAlloc ZweitesSegment2, "Modul-Segment (2)"
   MaxAlloc WeiteresSegment(1), "Prozedur-Array-Segment (1)"
   MaxAlloc WeiteresSegment(2), "Prozedur-Array-Segment (2)"
   MaxAlloc DrittesSegment1, "Prozedur-Stringsegment (1)"
   MaxAlloc DrittesSegment2, "Prozedur-Stringsegment (2)"

END SUB

