DECLARE SUB SchreibeTastaturPuffer (Text AS STRING)
'$FORM XPROF
DECLARE SUB WriteState (File AS INTEGER, Object AS CONTROL)
DECLARE SUB ReadState (File AS INTEGER, Object AS CONTROL)
REM $INCLUDE: 'Constant.BI'

COMMON SHARED CRLF AS STRING * 2
OPTION EXPLICIT

SUB LoadSettings (FileName AS STRING)

	DIM FileNumber AS INTEGER

	FileNumber = FREEFILE
	OPEN FileName FOR BINARY AS #FileNumber
	ReadState FileNumber, XPROF.ArtCount
	ReadState FileNumber, XPROF.ArtCoverage
	ReadState FileNumber, XPROF.ArtSample
	ReadState FileNumber, XPROF.ArtTime
	ReadState FileNumber, XPROF.NachProz
	ReadState FileNumber, XPROF.NachZeilen
	ReadState FileNumber, XPROF.SortAlpha
	ReadState FileNumber, XPROF.SortNo
	ReadState FileNumber, XPROF.Sorttime
	ReadState FileNumber, XPROF.SortCount
	ReadState FileNumber, XPROF.SampleRate
	ReadState FileNumber, XPROF.OnlyCovered
	ReadState FileNumber, XPROF.TextEdit
	CLOSE FileNumber


END SUB

SUB ProgrammVerlassen ()

	' Damit man die Meldung "Stapeldatei fehlt" nicht lesen kann,
	' die beim automatischen Aufruf erzeugt wird
	SchreibeTastaturPuffer "CLS" + CHR$(13)
	Screen.HIDE
	CLS
	SYSTEM

END SUB

' Wenn das angegebene Objekt ein Textfeld ist, wird die Text-Eigenschaft aus der Datei gelesen.
' Bei allen anderen Objekten wird die Value-Eigenschaft gelesen; bei Options- und Kontrollfeldern
' nur als BYTE (-127 bis 128), sonst als INTEGER (-32768 bis 32767).
SUB ReadState (File AS INTEGER, Object AS CONTROL)

	DIM Char AS STRING * 1, Intg AS INTEGER, Text AS STRING

	IF TYPEOF Object IS TextBox THEN
		GET #File, , Intg: Text = SPACE$(Intg)
		GET #File, , Text: Object.Text = Text
	ELSEIF TYPEOF Object IS OptionButton THEN
		GET #File, , Char: Object.Value = ASC(Char) - 128
	ELSEIF TYPEOF Object IS CheckBox THEN
		GET #File, , Char: Object.Value = ASC(Char) - 128
	ELSE
		GET #File, , Intg: Object.Value = Intg
	END IF

END SUB

SUB SaveSettings (FileName AS STRING)

	ON LOCAL ERROR RESUME NEXT
	DIM FileNumber AS INTEGER
	FileNumber = FREEFILE

	OPEN FileName FOR BINARY AS #FileNumber
	WriteState FileNumber, XPROF.ArtCount
	WriteState FileNumber, XPROF.ArtCoverage
	WriteState FileNumber, XPROF.ArtSample
	WriteState FileNumber, XPROF.ArtTime
	WriteState FileNumber, XPROF.NachProz
	WriteState FileNumber, XPROF.NachZeilen
	WriteState FileNumber, XPROF.SortAlpha
	WriteState FileNumber, XPROF.SortNo
	WriteState FileNumber, XPROF.Sorttime
	WriteState FileNumber, XPROF.SortCount
	WriteState FileNumber, XPROF.SampleRate
	WriteState FileNumber, XPROF.OnlyCovered
	WriteState FileNumber, XPROF.TextEdit
	CLOSE FileNumber

END SUB

SUB SchreibeTastaturPuffer (Text AS STRING)

	DIM Zaehler AS INTEGER
	IF LEN(Text) > 15 THEN EXIT SUB

	DEF SEG = 0: POKE 1050, 30
	POKE 1052, 30 + 2 * LEN(Text)

	FOR Zaehler = 1 TO LEN(Text)
		POKE 1052 + 2 * Zaehler, ASC(MID$(Text, Zaehler, 1))
	NEXT

END SUB

SUB TextEditMode (Visible AS INTEGER)

	XPROF.Rahmen1.Visible = NOT Visible: XPROF.Rahmen2.Visible = NOT Visible
	XPROF.Rahmen3.Visible = NOT Visible: XPROF.Exefile.Visible = NOT Visible
	XPROF.Objects.Visible = NOT Visible: XPROF.Start.Visible = NOT Visible
	XPROF.Quit.Visible = NOT Visible: XPROF.ExeCaption.Visible = NOT Visible
	XPROF.TextEdit.Visible = Visible: XPROF.TextFinish.Visible = Visible
	XPROF.TextCancel.Visible = Visible: XPROF.TextHelp.Visible = Visible

END SUB

' Vgl. Kommentar bei ReadState!
SUB WriteState (File AS INTEGER, Object AS CONTROL)

	DIM Char AS STRING * 1, Intg AS INTEGER, Text AS STRING

	IF TYPEOF Object IS TextBox THEN
		Text = Object.Text: Intg = LEN(Text): PUT #File, , Intg: PUT #File, , Text
	ELSEIF TYPEOF Object IS OptionButton THEN
		Char = CHR$(Object.Value + 128): PUT #File, , Char
	ELSEIF TYPEOF Object IS CheckBox THEN
		Char = CHR$(Object.Value + 128): PUT #File, , Char
	ELSE
		Intg = Object.Value: PUT #File, , Intg
	END IF

END SUB

